<?php
/*======================================================================*\
|| #################################################################### ||
|| # Invite Add-on  2.1.2
|| # Build: 46
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2012 Daniel Fatkic aka ragtek. All Rights Reserved.   # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # http://www.ragtek.org                                            # ||
|| #################################################################### ||
\*======================================================================*/


class Ragtek_Invite_ControllerAdmin_Index extends XenForo_ControllerAdmin_Abstract
{
    protected function _preDispatch($action)
    {
        $this->assertAdminPermission('ragtek_manage_invites');
    }

    public function actionIndex()
    {
        $params = array(
            'userGroups' => $this->_getUsergroupModel()->getAllUserGroupTitles()
        );

        return $this->responseView('', 'ragtek_invite_index', $params);
    }


    public function actionGetAllInvites()
    {

        $filter = $this->_input->filterSingle('_filter', XenForo_Input::ARRAY_SIMPLE);

        if ($filter) {

            $filterView = true;
        }
        else
        {
            $filterView = false;
        }

        $invites = $this->_getInviteModel()->getAllInvites();

        $params = array(
            'invites' => $invites,
            'filterView' => $filterView,
            'totalInvites' => $this->_getInviteModel()->countAllInvites()
        );
        return $this->responseView('', 'ragtek_invite_inviteslist', $params);
    }

    public function actionDelete()
    {
        $inviteId = $this->_input->filterSingle('invite_id', XenForo_Input::UINT);
        $inviteModel = $this->_getInviteModel();

        $invite = $this->getRecordOrError(
            $inviteId, $inviteModel, 'getInviteFromId',
            'requested_user_not_found'
        );

        if ($this->isConfirmedPost()) {
            return $this->_deleteData(
                'Ragtek_Invite_DataWriter_Invite', 'invite_id',
                XenForo_Link::buildAdminLink('invites/getallinvites')
            );
        }
        else
        {
            $viewParams = array(
                'invite' => $invite
            );

            return $this->responseView('',
                                       'ragtek_invite_delete', $viewParams
            );
        }
    }


    public function actionGetName()
    {
        $username = $this->_input->filterSingle('username', XenForo_Input::STRING);
        /** @var $user XenForo_Model_User */
        $user = XenForo_Model::create('XenForo_Model_User');
        $user = $user->getUserByName($username);
        if (!is_array($user)) {
            $params = array(
            );
        }
        else {
            return $this->responseView('Ragtek_Invite_ViewAdmin_Index', 'foo', $user);
        }
        return $this->responseView('Ragtek_Invite_ViewAdmin_Index', 'foo', $params);
    }


    public function actionAddToGroup()
    {
        $userGroup = $this->_input->filterSingle('user_group_id', XenForo_Input::UINT);
        $onlyPrimary = $this->_input->filterSingle('onlyprimary', XenForo_Input::UINT);

        $invites = $this->_input->filterSingle('invitesgroup', XenForo_Input::UINT);

        $this->getModelFromCache('Ragtek_Invite_Model_Invite')->addInvites($userGroup, $invites, $onlyPrimary);
        return $this->responseRedirect(
            XenForo_ControllerResponse_Redirect::SUCCESS,
            XenForo_Link::buildAdminLink('invites'),
            'invites saved');
    }

    public function actionManage()
    {
        $user = $this->_input->filterSingle('username', XenForo_Input::STRING);
        $invites = $this->_input->filterSingle('invites', XenForo_Input::UINT);
        $user = $this->_getUserModel()->getUserByName($user);

        $this->_getInviteModel()->setUserInvites($user['user_id'], $invites);
        return $this->responseRedirect(
            XenForo_ControllerResponse_Redirect::SUCCESS,
            XenForo_Link::buildAdminLink('invites'),
            'invites saved');
    }

    /**
     * @return XenForo_Model_User
     */
    protected function _getUserModel()
    {
        return $this->getModelFromCache('XenForo_Model_User');
    }

    /**
     * @return XenForo_Model_Usergroup
     */
    protected function _getUsergroupModel()
    {
        return $this->getModelFromCache('XenForo_Model_UserGroup');
    }

    /**
     * @return Ragtek_Invite_Model_Invite
     */
    protected function _getInviteModel()
    {
        return $this->getModelFromCache('Ragtek_Invite_Model_Invite');
    }
}
 
