<?php
/*======================================================================*\
|| #################################################################### ||
|| # Invite Add-on  2.1.2
|| # Build: 46
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2012 Daniel Fatkic aka ragtek. All Rights Reserved.   # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # http://www.ragtek.org                                            # ||
|| #################################################################### ||
\*======================================================================*/


    class Ragtek_Invite_ControllerPublic_Index extends XenForo_ControllerPublic_Account
    {

        protected function _preDispatch($action)
        {
            parent::_preDispatch($action);
            if (!Ragtek_Invite_Helper::perm('canUse')) {
                return $this->responseNoPermission();
            }
        }
        /*
        * i know the 2 methods are unneccesery but i was to lazy ...
        *
        *
        */

        public function actionIndex()
        {

            return $this->_getInviteWrapper('ragtek_invite');
        }

        public function actionGetList()
        {

            return $this->_getInviteWrapper('ragtek_inviteUserList', true);
        }



        public function actionDelete()
        {
            $invite_id = $this->_input->filterSingle('invite_id', XenForo_Input::UINT);
            $invite = $this->_getInviteModel()->getInviteFromId($invite_id);
            if ($this->_request->isPost()) {
                $this->_getInviteModel()->deleteInvite($invite_id);
                return $this->responseRedirect(
                    XenForo_ControllerResponse_Redirect::SUCCESS,
                    XenForo_Link::buildPublicLink('invites#invitestab'),
                    'deleted'
                );
            }
            else {
                $params = array(
                    'invite' => $invite
                );
                return $this->_getInviteWrapper('ragtek_inviteConfirmDelete', true, $params);
            }
        }

        public function actionInvite()
        {
            $this->_assertPostOnly();
            $inviteModel = $this->_getInviteModel();
            $email = $this->_input->filterSingle('email', XenForo_Input::STRING);
            $name = $this->_input->filterSingle('username', XenForo_Input::STRING);

            if (!$inviteModel->createAndSendInvite($name, $email)) {
                throw $this->getErrorOrNoPermissionResponseException('ragtek_invite_no_free');
            }

            return $this->responseRedirect(
                XenForo_ControllerResponse_Redirect::SUCCESS,
                XenForo_Link::buildPublicLink('invites'),
                new XenForo_Phrase('your_invite_has_been_sent')
            );
        }

        private function getViewParams($fetchAll = true)
        {
            $visitor = XenForo_Visitor::getInstance();
            $visitorId = XenForo_Visitor::getUserId();

            $inviteModel = $this->_getInviteModel();
            $canInvite = $inviteModel->canInvite($visitor);


            $viewParams = array(
                'canInvite' => $canInvite,
                'referrerUrl' => XenForo_Link::buildPublicLink('full:index', null, array('ref' => $visitorId)),
                'referredUsers' => $inviteModel->getReferredUsers($visitorId),
                'canDeleteInvite' => $inviteModel->canDeleteInvite(),
                'invitedUsersCount' => $inviteModel->countInvitedUsers($visitorId),
                'freeInvites' => $inviteModel->getFreeInvites($visitorId)
            );

            if ($fetchAll) {
                $viewParams['invitedUsers'] = $inviteModel->getInvitedUsers($visitorId);
            }

            return $viewParams;
        }

        public function actionValidateField()
        {
            $this->_assertPostOnly();
            $field = $this->_getFieldValidationInputParams();

            $data = array(
                'name' => 'invited_mail',
                'value' => $field['value']
            );

            return $this->_validateField('Ragtek_Invite_DataWriter_Invite',
                                         $data
            );
        }

        public static function getSessionActivityDetailsForList(array $activities)
        {
            return new XenForo_Phrase('ragtek_invite_managing_invites');
        }



        protected function _getInviteWrapper($template, $getAllParams = false, array $additionalParams = array())
        {
            $params = array_merge($additionalParams, $this->getViewParams($getAllParams));
            return parent::_getWrapper('invites', 'manage', $this->responseView('Ragtek_Invite_View', $template, $params));
        }

        /**
         *
         * @return Ragtek_Invite_Model_Invite
         */
        protected function _getInviteModel()
        {
            return $this->getModelFromCache('Ragtek_Invite_Model_Invite');
        }
    }