<?php
/*======================================================================*\
|| #################################################################### ||
|| # Invite Add-on  2.1.2
|| # Build: 46
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2012 Daniel Fatkic aka ragtek. All Rights Reserved.   # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # http://www.ragtek.org                                            # ||
|| #################################################################### ||
\*======================================================================*/


    class Ragtek_Invite_DataWriter_User extends
        XFCP_Ragtek_Invite_DataWriter_User
    {
        protected function _postSave()
        {
            parent::_postSave();
            if ($this->isInsert()) {
                $newUserId = $this->get('user_id');
                $inviteModel = $this->_getInviteModel();

                if ($code = $inviteModel->getCookie()) {
                    $inviteModel->changeInvitePending($code, $newUserId);
                }
            }
        }

        protected function _getFields()
        {
            $fields = parent::_getFields();
            $fields['xf_user'] += array('ragtek_free_invites' => array('type' => self::TYPE_UINT, 'default' => XenForo_Application::get('options')->ragtek_invite_startInvites));
            $fields['xf_user'] += array('ragtek_referrer_userid' => array('type' => self::TYPE_UINT, 'default' => 0));
            return $fields;
        }


        protected function _postDelete()
        {
            parent::_postDelete();
            $this->_getInviteModel()->deleteInviteForUserId($this->get('user_id'));
        }

        /**
         * @return Ragtek_Invite_Model_Invite
         */
        protected function _getInviteModel()
        {
            return $this->getModelFromCache('Ragtek_Invite_Model_Invite');
        }
    }