<?php
/*======================================================================*\
|| #################################################################### ||
|| # Invite Add-on  2.1.2
|| # Build: 46
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2012 Daniel Fatkic aka ragtek. All Rights Reserved.   # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # http://www.ragtek.org                                            # ||
|| #################################################################### ||
\*======================================================================*/


    class Ragtek_Invite_StatsHandler extends XenForo_StatsHandler_Abstract
    {
        /**
         * Fetches raw stats data from the source tables between the dates provided.
         *
         * @param integer $startDate
         * @param integer $endDate
         *
         * @return array [subContentType => [ [date => total], [date => total] ] ]
         */
        public function getData($startDate, $endDate)
        {

            $invites = $this->_getDb()->fetchPairs(
                $this->_getBasicDataQuery(Ragtek_Invite_Model_Invite::TABLE_INVITE, 'date'),
                array($startDate, $endDate,)
            );

            return array(
                'invite' => $invites
            );
        }

        /**
         * Fetches an array of stats types handled by this class
         *
         * @return array [ stats_type => stats type phrase, ... ]
         */
        public function getStatsTypes()
        {
            return array(
                'invite' => new XenForo_Phrase('ragtek_invite_navbartab')
            );
        }

    }
